
% calculate the value for t>=T if policy follows the taylor rule in the
% backward-looking model and there are no more shocks
keep_loss_taylor = zeros(n_x,n_pi,3) ;

for vvv=1:3;
    if vvv==1; gamma=gammaA ; phi = phiA ; end
    if vvv==2; gamma=gammaB ; phi = phiB ;  end
    if vvv==3; gamma=gammaC ; phi = phiC ;  end
    
    % predefine
    %     int_polSST = zeros(n_x,n_pi) ;
    %     x_polSST   = zeros(n_x,n_pi) ;
    %     pi_polSST  = zeros(n_x,n_pi) ;
    %     lossSST    = zeros(n_x,n_pi) ;
    
    
    try_x = 1/(1+gamma/sigma+kappa*phi/sigma)*(delta*grid_xS - 1/sigma*( rho_end - rho_end - grid_piS) -phi/sigma*ksi*grid_piS ) ;
    try_pi = ksi*grid_piS + kappa*try_x ;
    try_x2 = delta*grid_xS - 1/sigma*( ZLBI - rho_end - grid_piS ) ;
    try_pi2 = ksi*grid_piS + kappa*try_x2 ;
    
    I1  = (try_x*gamma+try_pi*phi + rho_end >=ZLBI) ;
    I2 =  (try_x2*gamma+try_pi2*phi+ rho_end <ZLBI) ;
    
    x_polSST = try_x.*I1 + I2.*try_x2 ;
    pi_polSST = try_pi.*I1 + try_pi2.*I2 ;
    int_polSST  = I1.*(try_x*gamma+try_pi*phi+ rho_end) ;
    
    
    Mpi_polSST = max(pi_polSST,lpi) ;
    Mx_polSST = max(x_polSST,lx) ;
    % problem - under rule A (follow natural rate, not Taylor), there is an inflationary
    % trap too. hence:
    Mpi_polSST = min(Mpi_polSST,upi) ;
    Mx_polSST = min(Mx_polSST,ux) ;
    % this implicitely assumes some other policy intervention to
    % prevent inflationary eq
    
    lossSST = zeros(n_x,n_pi) ;
    prec = 1e-6 ; err = 1 ;
    iter = 1 ; maxiter =1e4 ;
    while err>prec&&iter<maxiter
        iter = iter + 1 ; 
        lossSSTnew = x_polSST.^2*lambda + pi_polSST.^2 + beta*interp2(grid_pi,grid_x,lossSST,Mpi_polSST,Mx_polSST,'linear') ;
        err = max(max(abs(lossSSTnew-lossSST))) ; 
        lossSST = lossSSTnew ; 
    end
    
    disp(err)
    
    
    keep_loss_taylor(:,:,vvv) = lossSSTnew ;
end
